#2566 closed defect (fixed)

m68k/gen68360: linker script update (add KEEP() sections)

Reported by: Joel Sherrill Owned by: Joel Sherrill
Priority: normal Milestone: Indefinite
Component: bsps Version: 5
Severity: normal Keywords: function sections, KEEP
Cc: Blocked By:
Blocking:

Description

This BSP's linker script does not include KEEP() directives and thus cannot have per-function and per-data element section support enabled.

The preferred solution is to convert the BSP to use a shared base linker script. The acceptable solution is to add the proper KEEP directives to the existing linker script(s).

Shared linker scripts for the arm, m68k, and sparc have the proper KEEP sections and can serve as examples.

Change History (5)

comment:1 Changed on Feb 15, 2017 at 1:49:47 PM by Sebastian Huber

Owner: set to Joel Sherrill
Status: newassigned

comment:2 Changed on May 11, 2017 at 7:31:02 AM by Sebastian Huber

Milestone: 4.124.12.0

comment:3 Changed on Aug 24, 2017 at 5:59:58 AM by Sebastian Huber

Milestone: 4.12.0Indefinite

comment:4 Changed on Sep 14, 2018 at 6:58:59 PM by Joel Sherrill

Keywords: function sections KEEP added

comment:5 Changed on Nov 25, 2018 at 3:35:01 PM by Shashvat Jain <shashvatjain2002@…>

Resolution: fixed
Status: assignedclosed

In ffe9e7a/rtems:

m68k/gen68360:Add per-section compilation and linking support

The size of the sample executables without this option were:

text data bss dec hex filename

76560 1200 19504 97264 17bf0 ./base_sp.exe

191776 2160 22448 216384 34d40 ./capture.exe
243760 2976 20496 267232 413e0 ./cdtest.exe
827184 21872 26928 875984 d5dd0 ./cxx_iostream.exe
532960 4688 31904 569552 8b0d0 ./fileio.exe

97888 1472 19360 118720 1cfc0 ./hello.exe

250368 6080 26272 282720 45060 ./loopback.exe

34336 304 15056 49696 c220 ./minimum.exe
99840 1680 19616 121136 1d930 ./nsecs.exe

185936 1968 20240 208144 32d10 ./paranoia.exe
414992 12096 49072 476160 74400 ./pppd.exe

79472 1232 19536 100240 18790 ./ticker.exe
66368 1088 23120 90576 161d0 ./unlimited.exe

The size of the sample executables with this option were:

text data bss dec hex filename

59200 1120 19136 79456 13660 ./base_sp.exe

178912 2160 22400 203472 31ad0 ./capture.exe
163712 2112 20160 185984 2d680 ./cdtest.exe
163696 2192 20352 186240 2d780 ./cxx_iostream.exe
521344 4672 31584 557600 88220 ./fileio.exe

89600 1472 19328 110400 1af40 ./hello.exe

222384 5984 25920 254288 3e150 ./loopback.exe

33728 304 15024 49056 bfa0 ./minimum.exe
81280 1584 19248 102112 18ee0 ./nsecs.exe

164960 1872 19904 186736 2d970 ./paranoia.exe
402928 12096 48992 464016 71490 ./pppd.exe

62112 1136 19168 82416 141f0 ./ticker.exe
64864 1072 23088 89024 15bc0 ./unlimited.exe

Closes #2566.

Note: See TracTickets for help on using tickets.